]> git.madduck.net Git - etc/zsh.git/blobdiff - .zsh/func/vcsh

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

disable gpg batch mode for getpw
[etc/zsh.git] / .zsh / func / vcsh
index e404efcc62e61f2140b9df7d7dcca71a37b4d848..bf5735ef7952330b1d1487326c24422bfa338e8e 100755 (executable)
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/zsh
 #
 # func/vcsh
 #
@@ -7,14 +7,17 @@
 # Copyright © 1994–2008 martin f. krafft <madduck@madduck.net>
 # Released under the terms of the Artistic Licence 2.0
 #
-# Source repository: http://git.madduck.net/v/etc/zsh.git
+# Source repository: git://git.madduck.net/etc/zsh.git
 #
 
-FGIT_BASE="$HOME/.fgits"
+## THIS SCRIPT IS DEPRECATED IN FAVOUR OF
+## https://github.com/RichiH/vcsh
+
+local FGIT_BASE="$HOME/.fgits"
 
 if [ "${1:---help}" = '--help' ] || [ $# -gt 1 ]; then
-  echo "usage: ${0%/*} reponame" >&2
-  echo "usage: ${0%/*} -l" >&2
+  echo "usage: ${0##*/} reponame" >&2
+  echo "usage: ${0##*/} -l" >&2
   [ "$1" = '--help' ]
   return $?
 
@@ -31,7 +34,15 @@ if [ ! -d "$FGIT_BASE/${1}.git" ]; then
   return 2
 fi
 
-export GIT_DIR=$FGIT_BASE/${1}.git
-git status
+old_GIT_DIR="${GIT_DIR:-}"
+old_GIT_WORK_TREE="${GIT_WORK_TREE:-}"
+
+export GIT_DIR="$FGIT_BASE/${1}.git"
+export GIT_WORK_TREE="$GIT_DIR/$(git config --get core.worktree)"
+
+PS1="%S{${0##*/}:$1}%s$PS1" $SHELL -i || :
 
-PS1="%S{VCSH:$1}%s$PS1" $SHELL -i
+GIT_DIR="$old_GIT_DIR"
+[ -z "$GIT_DIR" ] && unset GIT_DIR
+GIT_WORK_TREE="$old_GIT_WORK_TREE"
+[ -z "$GIT_WORK_TREE" ] && unset GIT_WORK_TREE